"""
heartbeat mechanism
"""
import time

import psutil

from lumo.kit.experiment import Experiment
from lumo.kit.params import BaseParams
from lumo.proc.date import strftime


def wait_pid_stop():
    params = BaseParams()
    params.pid = None
    params.test_name = None
    params.exp_name = None
    params.state_key = None
    params.from_args()

    exp = Experiment(params.exp_name, params.test_name)
    while psutil.pid_exists(params.pid):
        exp.dump_info(params.state_key, {
            'end': strftime(),
        }, append=True)

        with open(exp.root_branch.file(f'{hash(exp.test_root)}.hb', 'heartbeat'), 'w') as w:
            w.write(exp.test_root)

        time.sleep(2)


if __name__ == '__main__':
    wait_pid_stop()
